// FNEdit.cpp : implementation file
//
// MultiRen version 1.0
// Copyright  1998 Ziff-Davis, Inc.
// First published in PC Magazine, US Edition
// June 9, 1998
//
// Written by Gregory A. Wolking

#include "stdafx.h"
#include "resource.h"
#include "FNEdit.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CFNEdit

CFNEdit::CFNEdit()
{
}

CFNEdit::~CFNEdit()
{
}


BEGIN_MESSAGE_MAP(CFNEdit, CEdit)
	//{{AFX_MSG_MAP(CFNEdit)
	ON_WM_CHAR()
	//}}AFX_MSG_MAP
	ON_MESSAGE(WM_PASTE, OnPaste)
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CFNEdit message handlers

void CFNEdit::OnChar(UINT nChar, UINT nRepCnt, UINT nFlags) 
{
	CString		strContents;
	int			iSelStart, iSelEnd, iPos;

	if (nChar == '*')
	{
		GetSel(iSelStart, iSelEnd);
		GetWindowText(strContents);
		iPos = strContents.Find(nChar);
		if	(	
				(iPos >= 0) &&
				(	
					((iSelStart == 0) && (iSelEnd == -1)) ||
					((iSelStart >= 0) && (iPos < iSelStart)) ||
					((iSelEnd > 0) && (iPos > iSelEnd))
				)
			)
		{
			MessageBeep(MB_OK);
			return;
		}
	}
	if (strchr("\"/:;<>|", nChar) == NULL)
		CEdit::OnChar(nChar, nRepCnt, nFlags);
	else
		MessageBeep(MB_OK);
}

// Handles WM_PASTE command.
void CFNEdit::OnPaste(WPARAM, LPARAM)
{
	HANDLE		hCBData = NULL;
	const char	*pOldData = NULL;
	char		*pNewData = NULL, *pWork = NULL;
	int			iLen;
	BOOL		bAltered, bHasAsterisk;
	CString		strText;

	if (!OpenClipboard())		// Try to open clipboard.
		return;					// Done if call fails.
	if (!IsClipboardFormatAvailable(CF_TEXT))	// Does clipboard contain CF_TEXT?
	{
		CloseClipboard();						// Done if not.
		return;
	}
	hCBData = GetClipboardData(CF_TEXT);	// Get handle to clipboard data in CF_TEXT format.
	if (hCBData == NULL)					// Clean up and quit if call fails.					
	{
		CloseClipboard();
		return;
	}
	pOldData = (char *) GlobalLock(hCBData);	// Lock handle to the clipboard data.
	iLen = strlen(pOldData);					// Get string length.
	pNewData = new char[iLen + 1];				// Create array to hold clibpoard data.
	if (pOldData == NULL || pNewData == NULL)	// Clean up and bail if pointers are not valid.
	{
		if (pOldData != NULL)			// If pointer is not NULL,
			GlobalUnlock(hCBData);		// be sure to unlock the data.
		CloseClipboard();				// Relesae the clipboard.
		if (pNewData != NULL)			// If pointer is non-null,
			delete [] pNewData;			// delete the array.
		return;							// Done.
	}
	lstrcpy(pNewData, pOldData);		// Get a copy of the clipboard data.
	GlobalUnlock(hCBData);				// Release the handle.
	CloseClipboard();					// Close the clipboard.
	pWork = pNewData;					// Get pointer to new data.
	bAltered = FALSE;					// Clear modified flag.
	while (*pWork)						// Convert illegal filename characters to $ signs.
	{
		if (strchr("\"/:;<>|", *pWork) != NULL)
		{
			*pWork = '$';
			bAltered = TRUE;			// Character was changed, so set flag.
		}
		++pWork;
	}
	ReplaceSel(pNewData, TRUE);			// Replace current selection with new text.
	delete [] pNewData;					// Delete the array.
	pNewData = NULL;
//	if (bAltered)						// Present warning if characters had to be translated.
//		AfxMessageBox("WARNING: The text you pasted contains characters\n"
//			"that are not allowed in filenames. Those characters\n"
//			"have been converted to $ signs.", MB_ICONINFORMATION);
	GetWindowText(strText);				// Retrieve the modified text.
	pOldData = (LPCTSTR) strText;		// Get pointer to the modified text.
	iLen = strText.GetLength() + 1;		// Allocate buffer to hold new text.
	pNewData = new char[iLen];
	if (pNewData == NULL)				// Bail if allocation fails.
		return;
	pWork = pNewData;					// Get pointer to new data.
	bAltered = FALSE;					// Clear modified flag.
	bHasAsterisk = FALSE;				// Clear asterisk flag.
	while (*pOldData)					// Copy new string to old.
	{
		*pWork = *pOldData;
		if (*pOldData == '*')			// If current character is an asterisk,
		{
			if (bHasAsterisk)			// and we've already copied one,
			{
				bAltered = TRUE;		// Set modified flag.
				--pWork;				// Back up so asterisks won't be copied.
			}
			else						// Otherwise,
			{
				bHasAsterisk = TRUE;	// set the flag.
			}
		}
		++pOldData;
		++pWork;
	}
	*pWork = '\0';						// Make sure new string is terminated.
	if (bAltered)						// If text was modified,
		SetWindowText(pNewData);		// install new text.
	delete [] pNewData;					// Delete the array.
}
