// MRSetup.cpp : Defines the class behaviors for the application.
//
// MultiRen version 1.0
// Copyright  1998 Ziff-Davis, Inc.
// First published in PC Magazine, US Edition
// June 9, 1998
//
// Written by Gregory A. Wolking

#include "stdafx.h"
#include "MRSetup.h"
#include "SetupDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CMRSetupApp

BEGIN_MESSAGE_MAP(CMRSetupApp, CWinApp)
	//{{AFX_MSG_MAP(CMRSetupApp)
		// NOTE - the ClassWizard will add and remove mapping macros here.
		//    DO NOT EDIT what you see in these blocks of generated code!
	//}}AFX_MSG
	ON_COMMAND(ID_HELP, CWinApp::OnHelp)
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CMRSetupApp construction

CMRSetupApp::CMRSetupApp()
{
	// TODO: add construction code here,
	// Place all significant initialization in InitInstance
}

/////////////////////////////////////////////////////////////////////////////
// The one and only CMRSetupApp object

CMRSetupApp thisApp;

/////////////////////////////////////////////////////////////////////////////
// CMRSetupApp initialization

BOOL CMRSetupApp::InitInstance()
{
	HINSTANCE hInstDll = NULL;
	CString strFileName, strRootPath;
	int iPos;
	UINT nDriveType = 0;

	// Get fully-qualified filename of our executable file.
	GetModuleFileName(AfxGetInstanceHandle(), strFileName.GetBuffer(_MAX_PATH), _MAX_PATH);
	strFileName.ReleaseBuffer();
	iPos = strFileName.Find('\\') + 1;		// Extract path to root directory of source drive.
	strRootPath = strFileName.Left(iPos);
	nDriveType = GetDriveType(strRootPath);	// Retrieve drive type information.

	if (nDriveType != DRIVE_FIXED)			// Is it a fixed disk?
	{
		AfxMessageBox(IDP_NO_REMOVABLE, MB_ICONSTOP);		// Error message and quit if not.
		return FALSE;
	}
	iPos = strFileName.ReverseFind('\\') + 1;	// Get fully-qualified name to MULTIREN.DLL.
	strFileName = strFileName.Left(iPos);
	strFileName += "MultiRen.dll";
	hInstDll = LoadLibrary(strFileName);		// Try to load the DLL into memory.
	if (hInstDll == NULL)						// Error message and quit if load fails.
	{
		AfxMessageBox("ERROR: Unable to load MultiRen.dll");
		return FALSE;
	}
	CSetupDlg dlg;					// Create main dialog.
	m_pMainWnd = &dlg;				// Dialog is our main window.
	dlg.m_hInstDll = hInstDll;		// Give dialog a copy of the DLL's instance handle.
	dlg.DoModal();					// Launch the dialog.
	FreeLibrary(hInstDll);			// Release the DLL.
	return FALSE;					// Done.
}
