// SetupDlg.cpp : implementation file
//
// MultiRen version 1.0
// Copyright  1998 Ziff-Davis, Inc.
// First published in PC Magazine, US Edition
// June 9, 1998
//
// Written by Gregory A. Wolking

#include "stdafx.h"
#include "MRSetup.h"
#include "SetupDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CSetupDlg dialog

CSetupDlg::CSetupDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CSetupDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CSetupDlg)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
	m_hIcon = (HICON) LoadImage(AfxGetApp()->m_hInstance, MAKEINTRESOURCE(IDI_ICON1), IMAGE_ICON, 16, 16, LR_DEFAULTCOLOR); 
}

void CSetupDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CSetupDlg)
		// NOTE: the ClassWizard will add DDX and DDV calls here
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CSetupDlg, CDialog)
	//{{AFX_MSG_MAP(CSetupDlg)
	ON_BN_CLICKED(IDC_cmdInstall, OncmdInstall)
	ON_BN_CLICKED(IDC_cmdRemove, OncmdRemove)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CSetupDlg message handlers




void CSetupDlg::OncmdInstall() 
{
	Do_Install(TRUE);
}

void CSetupDlg::OncmdRemove() 
{
	Do_Install(FALSE);
}

// Does the work.
// bFlag indicates action to perform:
//    TRUE = install
//    FALSE = uninstall.
void CSetupDlg::Do_Install(BOOL bFlag)
{
	FARPROC pFunc = NULL;
	HKEY hUninstallKey, hMyKey;
	CString strFileName, strParentFolder, strTest;
	DWORD dwDisposition;
	int iPos;
	BOOL bFilesMissing = FALSE;

	// Get fully qualified name of our executable file.
	GetModuleFileName(AfxGetInstanceHandle(), strFileName.GetBuffer(_MAX_PATH), _MAX_PATH);
	strFileName.ReleaseBuffer();
	// Extract Parent folder
	iPos = strFileName.ReverseFind('\\') + 1;
	strParentFolder = strFileName.Left(iPos);
	// Get appropriate function address.
	if (bFlag)
		pFunc = GetProcAddress(m_hInstDll, "DllRegisterServer");
	else
		pFunc = GetProcAddress(m_hInstDll, "DllUnregisterServer");
	if (pFunc != NULL)	// If function address was found,
	{
		if (bFlag)		// Are we installing?
		{
			// Make sure that .HLP and .CNT files are present.
			strTest = strParentFolder + "MULTIREN.HLP";
			if (!File_Exists(strTest))
				bFilesMissing = TRUE;
			else
			{
				strTest = strParentFolder + "MULTIREN.CNT";
				if (!File_Exists(strTest))
					bFilesMissing = TRUE;
			}
			// Create keys for Windows Setup.
			if (!bFilesMissing)
			{
				RegOpenKeyEx(HKEY_LOCAL_MACHINE,
					"SOFTWARE\\Microsoft\\Windows\\CurrentVersion\\Uninstall",
					0, KEY_ALL_ACCESS, &hUninstallKey);
				RegCreateKeyEx(hUninstallKey, "MultiRen", 0, NULL, REG_OPTION_NON_VOLATILE, KEY_SET_VALUE, NULL, &hMyKey, &dwDisposition);
				RegSetValueEx(hMyKey, "DisplayName", 0, REG_SZ, (LPBYTE) "MultiRen Shell Extension", 25);
				RegSetValueEx(hMyKey, "UninstallString", 0, REG_SZ, (LPBYTE) (LPCTSTR) strFileName, strFileName.GetLength() + 1);
				RegCloseKey(hMyKey);
				RegCloseKey(hUninstallKey);
				AfxMessageBox("MultiRen is now installed.", MB_ICONINFORMATION);
			}
			else // Error message if any files are missing.
			{
				AfxMessageBox("All of MultiRen's component files\n"
					"(MRSETUP.EXE, MULTIREN.DLL, MULTIREN.HLP and MULTIREN.CNT)\n"
					"must be in the same folder.\n\n"
					"Installation aborted.", MB_ICONSTOP);
			}
		}
		else	// Otherwise, do uninstall.
		{
			// Delete user settings.
			RegDeleteKey(HKEY_CURRENT_USER, "Software\\PC Magazine\\MultiRen");
			// Delete Uninstall key.
			RegDeleteKey(HKEY_LOCAL_MACHINE, "SOFTWARE\\Microsoft\\Windows\\CurrentVersion\\Uninstall\\MultiRen");
			AfxFormatString1(strTest, IDP_SUCCESS, strParentFolder);
			AfxMessageBox(strTest, MB_ICONINFORMATION);
		}
		// Call function to add or remove OLE information.
		pFunc();
	}
	else
		AfxMessageBox("Failed to access function in MultiRen.dll");
	EndDialog(IDOK);
}

BOOL CSetupDlg::File_Exists(LPCTSTR pszFileName)
{
	CFileStatus rStatus;
	rStatus.m_size = 0;
	CFile::GetStatus(pszFileName, rStatus);
	return (rStatus.m_size != 0);
}

BOOL CSetupDlg::OnInitDialog() 
{
	CDialog::OnInitDialog();
	

	SetIcon(m_hIcon, FALSE);
	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}
