// MultiRen.cpp : Defines the initialization routines for the DLL.
//
// MultiRen version 1.0
// Copyright  1998 Ziff-Davis, Inc.
// First published in PC Magazine, US Edition
// June 9, 1998
//
// Written by Gregory A. Wolking

#include "stdafx.h"
#include <windows.h>
#include <initguid.h>
#include <shlobj.h>
#include "MultiRen.h"
#include "RenDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

// Global variables

UINT g_cRefThisDll = 0;

STDAPI DllGetClassObject (REFCLSID, REFIID, LPVOID*);
STDAPI DllCanUnloadNow ();
STDAPI DllRegisterServer ();
STDAPI DllUnregisterServer ();

void UpdateRegistry(BOOL);
HKEY CreateRegKey(CString, CString, BOOL bClose = FALSE);
void DeleteRegKey(CString);
void CreateRegValue(HKEY, CString, CString, BOOL bClose = FALSE);


//
//	Note!
//
//		If this DLL is dynamically linked against the MFC
//		DLLs, any functions exported from this DLL which
//		call into MFC must have the AFX_MANAGE_STATE macro
//		added at the very beginning of the function.
//
//		For example:
//
//		extern "C" BOOL PASCAL EXPORT ExportedFunction()
//		{
//			AFX_MANAGE_STATE(AfxGetStaticModuleState());
//			// normal function body here
//		}
//
//		It is very important that this macro appear in each
//		function, prior to any calls into MFC.  This means that
//		it must appear as the first statement within the 
//		function, even before any object variable declarations
//		as their constructors may generate calls into the MFC
//		DLL.
//
//		Please see MFC Technical Notes 33 and 58 for additional
//		details.
//

/////////////////////////////////////////////////////////////////////////////
// CMultiRenApp

BEGIN_MESSAGE_MAP(CMultiRenApp, CWinApp)
	//{{AFX_MSG_MAP(CMultiRenApp)
		// NOTE - the ClassWizard will add and remove mapping macros here.
		//    DO NOT EDIT what you see in these blocks of generated code!
	//}}AFX_MSG_MAP
	ON_COMMAND(ID_HELP, CWinApp::OnHelp)
//	ON_COMMAND(ID_HELP_FINDER, CWinApp::OnHelpFinder)
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CMultiRenApp construction

CMultiRenApp::CMultiRenApp()
{
	// TODO: add construction code here,
	// Place all significant initialization in InitInstance
}

/////////////////////////////////////////////////////////////////////////////
// The one and only CMultiRenApp object

CMultiRenApp theApp;

/////////////////////////////////////////////////////////////////////////////
// CMultiRenApp initialization

BOOL CMultiRenApp::InitInstance()
{
	// Register all OLE server (factories) as running.  This enables the
	//  OLE libraries to create objects from other applications.
	COleObjectFactory::RegisterAll();
	SetRegistryKey("PC Magazine");
	return TRUE;
}

/////////////////////////////////////////////////////////////////////////////
// Special entry points required for inproc servers
STDAPI DllCanUnloadNow ()
{
    return (g_cRefThisDll == 0) ? S_OK : S_FALSE;
}

STDAPI DllRegisterServer(void)
{
	// Code to autoregister the server into the registry
	UpdateRegistry(TRUE);
	return S_OK;
}

STDAPI DllUnregisterServer(void)
{
	UpdateRegistry(FALSE);
	return S_OK;
}

STDAPI DllGetClassObject(REFCLSID rclsid, REFIID riid, LPVOID* ppvObj)
{
    *ppvObj = NULL; 
    if (rclsid != CLSID_MultiRenShellExt)
        return CLASS_E_CLASSNOTAVAILABLE;

    CClassFactory* pClassFactory = new CClassFactory;

    if (pClassFactory == NULL)
        return E_OUTOFMEMORY;

    HRESULT hr = pClassFactory->QueryInterface (riid, ppvObj);
    pClassFactory->Release ();
	return hr;
}

/////////////////////////////////////////////////////////////////////////////
// CClassFactory member functions

CClassFactory::CClassFactory ()
{
    m_cRef = 1;
    g_cRefThisDll++;
}

CClassFactory::~CClassFactory ()
{
    g_cRefThisDll--;
}

STDMETHODIMP CClassFactory::QueryInterface (REFIID riid, LPVOID* ppvObj)
{
    *ppvObj = NULL;
    HRESULT hr = E_NOINTERFACE;

    if ((riid == IID_IUnknown) || (riid == IID_IClassFactory)) {
        *ppvObj = this;
        hr = NOERROR;
        m_cRef++;
    }
    return hr;
}

STDMETHODIMP_(ULONG) CClassFactory::AddRef ()
{
    return ++m_cRef;
}

STDMETHODIMP_(ULONG) CClassFactory::Release ()
{
    if (--m_cRef == 0)
        delete this;
    return m_cRef;
}

STDMETHODIMP CClassFactory::CreateInstance (LPUNKNOWN pUnkOuter, REFIID riid,
    LPVOID* ppvObj)
{
    *ppvObj = NULL;
    if (pUnkOuter != NULL)
        return CLASS_E_NOAGGREGATION;

    CShellExtension* pShellExtension = new CShellExtension;

    if (pShellExtension == NULL)
        return E_OUTOFMEMORY;

    HRESULT hr = pShellExtension->QueryInterface (riid, ppvObj);
	if (hr == S_OK)
		pShellExtension->Release ();
    return hr;
}

STDMETHODIMP CClassFactory::LockServer (BOOL fLock)
{
    return E_NOTIMPL;
}
/////////////////////////////////////////////////////////////////////////////
// CShellExtension member functions

CShellExtension::CShellExtension ()
{
	// !!!!! BUG
	// VC++ 4.0 Incorrectly decrements m_cRef 1 too many times when building
	// a Win32 Debug version of the application. The macro here detects and adjusts
	// the number to 2 when we are building the debug version of the application
	// The reason for this is unknown.

/* #ifdef _DEBUG
    m_cRef = 2;				// BUG! in DEBUG build
#endif

#ifndef _DEBUG
	m_cRef = 1;				// Correctly compiled in RELEASE build
#endif */

	// The above bug is FIXED in VC++ 4.1!! Hooray!
	//ASSERT(FALSE);
	m_cRef = 1;
	m_pFileNames = NULL;
	m_pFileExtensions = NULL;
	m_nFileCount = 0;
	++g_cRefThisDll;
}

CShellExtension::~CShellExtension ()
{
	UINT i;

    --g_cRefThisDll;
	if (m_pFileNames != NULL)
	{
		for (i = 0; i < m_nFileCount; i++)
		{
			if (m_pFileNames[i] != NULL)
				delete [] m_pFileNames[i];
		}
		delete [] m_pFileNames;
	}
	if (m_pFileExtensions != NULL)
	{
		for (i = 0; i < m_nFileCount; i++)
		{
			if (m_pFileExtensions[i] != NULL)
				delete [] m_pFileExtensions[i];
		}
		delete [] m_pFileExtensions;
	}
}

STDMETHODIMP CShellExtension::QueryInterface (REFIID riid, LPVOID* ppvObj)
{
    *ppvObj = NULL;
    HRESULT hr = E_NOINTERFACE;

    if (riid == IID_IUnknown) {
        *ppvObj = (LPUNKNOWN) (LPSHELLPROPSHEETEXT) this;
        hr = NOERROR;
        m_cRef++;
    }
    else if (riid == IID_IShellExtInit) {
        *ppvObj = (LPSHELLEXTINIT) this;
        hr = NOERROR;
        m_cRef++;
	}
	else if (riid == IID_IContextMenu) {
		*ppvObj = (LPCONTEXTMENU) this;
		hr = NOERROR;
		m_cRef++;
    }
    return hr;
}

STDMETHODIMP_(ULONG) CShellExtension::AddRef ()
{
    return ++m_cRef;
}
 
STDMETHODIMP_(ULONG) CShellExtension::Release ()
{
	if (--m_cRef == 0)
        delete this;
    return m_cRef;
}

    
STDMETHODIMP CShellExtension::Initialize (LPCITEMIDLIST pidlFolder,
    LPDATAOBJECT lpdobj, HKEY hKeyProgID)
{
    STGMEDIUM medium;
	HDROP hDrop;
    FORMATETC fe = { CF_HDROP, NULL, DVASPECT_CONTENT, -1, TYMED_HGLOBAL };

    if (lpdobj == NULL)
        return E_FAIL;

    // Render the data referenced by the IDataObject pointer to an HGLOBAL
    // storage medium in CF_HDROP format.

    HRESULT hr = lpdobj->GetData (&fe, &medium);
    if (FAILED (hr))
        return E_FAIL;

    // If only one file is selected, fail the call.
    
	hr = E_FAIL;
	hDrop = (HDROP) medium.hGlobal;
	if (Check_Objects(hDrop))
	{
		if (Get_FileNames(hDrop));
			hr = NOERROR;
	}
    // Release the storage medium and return.
    
	ReleaseStgMedium (&medium);
    return hr;
}

// Add MultiLaunch entries to the context menu

STDMETHODIMP CShellExtension::QueryContextMenu( HMENU hmenu,UINT indexMenu,
    UINT idCmdFirst, UINT idCmdLast,UINT uFlags)
{
	UINT idCmd = idCmdFirst;

	InsertMenu(hmenu, indexMenu++, MF_SEPARATOR | MF_BYPOSITION, 0, NULL);
	// Create the menu entry
	InsertMenu(hmenu, indexMenu++, MF_STRING | MF_BYPOSITION, idCmd++, "M&ultiple Rename...");
	// Insert final separator
	InsertMenu(hmenu, indexMenu++, MF_SEPARATOR | MF_BYPOSITION, 0, NULL);
    return ResultFromScode(MAKE_SCODE(SEVERITY_SUCCESS, FACILITY_NULL, (USHORT)idCmd - idCmdFirst));
}

// Launch MultiLaunch associated application

STDMETHODIMP CShellExtension::InvokeCommand(LPCMINVOKECOMMANDINFO lpici)
{
//  Note: Since our extension only puts one command on the menu,
//  there's no need to check its identifier to know which command
//  the user selected.
//	UINT idCmd = LOWORD(lpici->lpVerb);
	CRenDlg dlg;
	dlg.m_pFileNames = m_pFileNames;
	dlg.m_pFileExtensions = m_pFileExtensions;
	dlg.m_nFileCount = m_nFileCount;
	dlg.m_strParentFolder = m_strParentFolder;
	dlg.m_bExecutablesInList = m_bExecutablesInList;
	dlg.m_bIsSystemFolder = m_bIsSystemFolder;
	dlg.DoModal();
    return NOERROR;
}

STDMETHODIMP CShellExtension::GetCommandString(UINT idCmd,UINT uType,
    UINT* pwReserved,LPSTR pszName,UINT cchMax)
{
    return NOERROR;
}

BOOL CShellExtension::Check_Objects(HDROP hDrop)
{
	char szFileName[_MAX_PATH];
	int iPos;
	UINT nFileCount, i;
	CString strWinDir;

	m_bIsSystemFolder = FALSE;
	nFileCount = DragQueryFile (hDrop, (UINT) -1, NULL, 0);
    if ( nFileCount > 1 )
	{
		CFileStatus status_info;
		for (i = 0; i < nFileCount; i++)
		{
			DragQueryFile(hDrop, i, szFileName, _MAX_PATH);
			CFile::GetStatus(szFileName, status_info);
			if ((status_info.m_attribute & 0x10) != 0)
				return FALSE;
			// Extract the path to the current file.
			iPos = strlen(szFileName);
			while ((iPos > 0) && (szFileName[iPos] != '\\'))
				--iPos;
			++iPos;
			szFileName[iPos] = '\0';
			// If this is the first file,
			if (i == 0)
			{
				// Just store the parent folder path.
				m_strParentFolder = szFileName;
			}
			else
			{
				// Otherwise, check it against existing path.
				if (m_strParentFolder.Compare(szFileName) != 0)
					// Quit if paths are not the same.
					return FALSE;
			}
		}
		m_nFileCount = nFileCount;
		strWinDir = getenv("windir");		// Retrieve path to windows "home" directory.
		if (strWinDir.Right(1) != '\\')		// Append trailing backslash if needed.
			strWinDir += "\\";
		if (strWinDir.CompareNoCase(m_strParentFolder) == 0)	// If same as parent folder,
			m_bIsSystemFolder = TRUE;			// Set flag (which will be passed on to CRenDlg)
		else									// Otherwise,
		{
			strWinDir = strWinDir + "SYSTEM\\";	// Append "SYSTEM\" to the path.
			if (strWinDir.CompareNoCase(m_strParentFolder) == 0) // Check parent folder again, set flag if match.
				m_bIsSystemFolder = TRUE;
		}	
		return TRUE;
	}
	return FALSE;
}

BOOL CShellExtension::Get_FileNames(HDROP hDrop)
{
	char szFileName[_MAX_PATH];
	UINT i;
	int iLen;
	char *bp, *ep;

	m_bExecutablesInList = FALSE;
	if ((m_pFileNames = new char* [m_nFileCount]) == NULL)
		return FALSE;
	if ((m_pFileExtensions = new char* [m_nFileCount]) == NULL)
	{
		delete [] m_pFileNames;
		m_pFileNames = NULL;
		return FALSE;
	}
	for (i = 0; i < m_nFileCount; i++)
		m_pFileNames[i] = m_pFileExtensions[i] = NULL;
	for (i = 0; i < m_nFileCount; i++)
	{
		iLen = DragQueryFile(hDrop, i, szFileName, _MAX_PATH);
		bp = ep = szFileName + iLen;
		while ((ep > szFileName) && (*ep != '.'))
			--ep;
		if (ep <= szFileName)
			ep = bp;
		else
		{
			// If we've already found one executable in the list,
			// no need to do all those comparisons again!
			if (!m_bExecutablesInList)
			{
				// Also no need to search if extension is not 4 chars long.
				if (strlen(ep) == 4)
				{
					// Check extension for executables, set flag if found
					if ((stricmp(ep, ".exe") == 0) ||
						(stricmp(ep, ".dll") == 0) ||
						(stricmp(ep, ".com") == 0) ||
						(stricmp(ep, ".vxd") == 0) ||
						(stricmp(ep, ".386") == 0) ||
						(stricmp(ep, ".sys") == 0) ||
						(stricmp(ep, ".ocx") == 0))
						m_bExecutablesInList = TRUE;
				}
			}
			*ep = 0;
			bp = ep;
			++ep;
		}
		while ((bp > szFileName) && (*bp != '\\'))
			--bp;
		++bp;
		iLen = strlen(bp) + 1;
		m_pFileNames[i] = new char[iLen];
		if (m_pFileNames[i] == NULL)
			return FALSE;
		lstrcpyn(m_pFileNames[i], bp, iLen);
		iLen = strlen(ep) + 1;
		m_pFileExtensions[i] = new char[iLen];
		if (m_pFileExtensions[i] == NULL)
			return FALSE;
		lstrcpyn(m_pFileExtensions[i], ep, iLen);
	}
	return TRUE;
}
// Helper function that registers and unregisters the DLL
void UpdateRegistry(BOOL Register)
{
	HKEY hKey;
	CString strCLSID = STRCLSID_MultiRenShellExt; 
	CString strProgID = STRPROGID_MultiRenShellExt;
	CString strDescription = STRDESCRIPTION_MultiRenShellExt;
	CString strFilename;

	// Get the full path to this dll
	GetModuleFileName(AfxGetInstanceHandle(), strFilename.GetBuffer(260), 260);
	strFilename.ReleaseBuffer();

	if (Register) {

		// Register the DLL

		(void) CreateRegKey(strProgID, strDescription, TRUE);
		(void) CreateRegKey(strProgID + "\\CLSID", strCLSID, TRUE);
		(void) CreateRegKey("CLSID\\" + strCLSID, strDescription, TRUE);
		(void) CreateRegKey("CLSID\\" + strCLSID + "\\ProgID", strProgID, TRUE);
		hKey = CreateRegKey("CLSID\\" + strCLSID + "\\InProcServer32", strFilename);
		CreateRegValue(hKey, "ThreadingModel", "Apartment", TRUE);
		// Register the Context Menu Handler
		(void) CreateRegKey("*\\shellex\\ContextMenuHandlers\\" + strProgID, strCLSID, TRUE);
	}
	else {
		// Unregister the DLL
		DeleteRegKey(strProgID);
		DeleteRegKey(strProgID + "\\CLSID");
		DeleteRegKey("CLSID\\" + strCLSID);
		DeleteRegKey("CLSID\\" + strCLSID + "\\ProgID");
		DeleteRegKey("CLSID\\" + strCLSID + "\\InProcServer32");
		// Unregister the Context Menu Handler
		DeleteRegKey("*\\shellex\\ContextMenuHandlers\\" + strProgID);
	}
}

// Helper functions for creating and destroying registry keys
// Note: Key is created releative to HKEY_CLASSES_ROOT.
// bClose parameter determines whether or not key should be closed
// after it is created. If TRUE, the returned HKEY value cannot be used.
HKEY CreateRegKey(CString strKey, CString strValue, BOOL bClose)
{
	HKEY hKey;
	DWORD Disposition;

	RegCreateKeyEx(HKEY_CLASSES_ROOT, strKey, 0, strValue.LockBuffer(), REG_OPTION_NON_VOLATILE, KEY_ALL_ACCESS, NULL, &hKey, &Disposition);
	strValue.UnlockBuffer();
	RegSetValueEx(hKey, NULL, 0, REG_SZ, (BYTE*)strValue.LockBuffer(), strValue.GetLength() + 1);
	strValue.UnlockBuffer();
	if (bClose)
		RegCloseKey(hKey);
	return hKey;
}

void DeleteRegKey(CString strKey)
{
	RegDeleteKey(HKEY_CLASSES_ROOT, strKey);
}

// Creates (or modifies) a value under the specified key, relative to HKEY_CLASSES_ROOT.
// bClose parameter determines whether or not the key should be closed
// after the value is updated.
void CreateRegValue(HKEY hKey, CString strValueName, CString strValue, BOOL bClose)
{
	RegSetValueEx(hKey, strValueName, 0, REG_SZ, (BYTE*)strValue.LockBuffer(), strValue.GetLength() + 1);
	strValue.UnlockBuffer();
	if (bClose)
		RegCloseKey(hKey);
}

