// MultiRen.h : main header file for the MULTIREN DLL
//
// MultiRen version 1.0
// Copyright  1998 Ziff-Davis, Inc.
// First published in PC Magazine, US Edition
// June 9, 1998
//
// Written by Gregory A. Wolking

#if !defined(AFX_MULTIREN_H__8DC811CA_971D_11D1_A469_444553540000__INCLUDED_)
#define AFX_MULTIREN_H__8DC811CA_971D_11D1_A469_444553540000__INCLUDED_

#if _MSC_VER >= 1000
#pragma once
#endif // _MSC_VER >= 1000

#ifndef __AFXWIN_H__
	#error include 'stdafx.h' before including this file for PCH
#endif

#include <objbase.h>
#include <shlobj.h>
#include "resource.h"		// main symbols
// {8CBCE7E1-9760-11d1-A469-444553540000}
DEFINE_GUID(CLSID_MultiRenShellExt, 
0x8cbce7e1, 0x9760, 0x11d1, 0xa4, 0x69, 0x44, 0x45, 0x53, 0x54, 0x0, 0x0);
#define STRCLSID_MultiRenShellExt "{8CBCE7E1-9760-11d1-A469-444553540000}"
#define STRPROGID_MultiRenShellExt "MultiRen"
#define STRDESCRIPTION_MultiRenShellExt "MultiRen Copyright (c) 1998 Ziff-Davis Publishing"

#define WM_MY_ITEM_MOVED (WM_USER + 1)



/////////////////////////////////////////////////////////////////////////////
// CMultiRenApp
// See MultiRen.cpp for the implementation of this class
//

class CMultiRenApp : public CWinApp
{
public:
	CMultiRenApp();

// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CMultiRenApp)
	public:
	virtual BOOL InitInstance();
	//}}AFX_VIRTUAL

	//{{AFX_MSG(CMultiRenApp)
		// NOTE - the ClassWizard will add and remove member functions here.
		//    DO NOT EDIT what you see in these blocks of generated code !
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

/////////////////////////////////////////////////////////////////////////////
// Classes
 
class CClassFactory : public IClassFactory
{
protected:
    ULONG m_cRef;
    
public:
    CClassFactory ();
    ~CClassFactory ();
        
    // IUnknown methods
    STDMETHODIMP            QueryInterface (REFIID, LPVOID*);
    STDMETHODIMP_(ULONG)    AddRef ();
    STDMETHODIMP_(ULONG)    Release ();
    
    // IClassFactory methods
    STDMETHODIMP CreateInstance (LPUNKNOWN, REFIID, LPVOID*);
    STDMETHODIMP LockServer (BOOL);
};

class CShellExtension : public IShellExtInit, IContextMenu
{
protected:
    ULONG   m_cRef;

public:
    CShellExtension ();
    ~CShellExtension ();

	// Variables.
	CString m_strParentFolder;
	char ** m_pFileNames;
	char ** m_pFileExtensions;
	UINT	m_nFileCount;
    
    // IUnknown methods
    STDMETHODIMP            QueryInterface (REFIID, LPVOID*);
    STDMETHODIMP_(ULONG)    AddRef ();
    STDMETHODIMP_(ULONG)    Release ();
    
    // IShellExtInit method
    STDMETHODIMP Initialize (LPCITEMIDLIST, LPDATAOBJECT, HKEY);

	// IContextMenu methods
	STDMETHODIMP QueryContextMenu (HMENU, UINT, UINT, UINT, UINT);
	STDMETHODIMP InvokeCommand (LPCMINVOKECOMMANDINFO);
	STDMETHODIMP GetCommandString (UINT, UINT, UINT*, LPSTR, UINT);
private:
	// Member variables.
	BOOL m_bIsSystemFolder;
	BOOL m_bExecutablesInList;
	// Member functions.
	BOOL Get_FileNames(HDROP hDrop);
	BOOL Check_Objects(HDROP hDrop);
};

/////////////////////////////////////////////////////////////////////////////

//{{AFX_INSERT_LOCATION}}
// Microsoft Developer Studio will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_MULTIREN_H__8DC811CA_971D_11D1_A469_444553540000__INCLUDED_)
