// MultiRen version 1.0
// Copyright  1998 Ziff-Davis, Inc.
// First published in PC Magazine, US Edition
// June 9, 1998
//
// Written by Gregory A. Wolking
#if !defined(AFX_RENDLG_H__8DC811D2_971D_11D1_A469_444553540000__INCLUDED_)
#define AFX_RENDLG_H__8DC811D2_971D_11D1_A469_444553540000__INCLUDED_

#if _MSC_VER >= 1000
#pragma once
#endif // _MSC_VER >= 1000
// RenDlg.h : header file
//
// Required for the CFNEdit control class
#include "FNEdit.h"
// Required for CMRListCtrl class
#include "MRListCt.h"

/////////////////////////////////////////////////////////////////////////////
// CRenDlg dialog

class CRenDlg : public CDialog
{
// Construction
public:
	// Member variables.
	UINT	m_nFileCount;
	UINT	m_intDigits;
	UINT	m_intBase;
	BOOL	m_bIsSystemFolder;
	BOOL	m_bExecutablesInList;
	CString m_strParentFolder;
	char ** m_pFileNames;
	char ** m_pFileExtensions;
	// Member functions.
	CRenDlg(CWnd* pParent = NULL);   // standard constructor
	static int CALLBACK Compare_List_Items(LPARAM lParam1, LPARAM lParam2, LPARAM nData);

// Dialog Data
	//{{AFX_DATA(CRenDlg)
	enum { IDD = IDD_RENDLG };
	CButton	m_cmdSaveSettings;
	CStatic	m_lblWarning;
	CSpinButtonCtrl	m_spnDigits;
	CEdit	m_txtStart;
	CFNEdit	m_txtExtTemplate;
	CEdit	m_txtDigits;
	CFNEdit	m_txtBaseTemplate;
	CButton	m_cmdExecute;
	CMRListCtrl	m_lstFiles;
	BOOL	m_bUndo;
	//}}AFX_DATA


// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CRenDlg)
	public:
	virtual BOOL DestroyWindow();
	virtual BOOL PreTranslateMessage(MSG* pMsg);
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:

	// Generated message map functions
	//{{AFX_MSG(CRenDlg)
	virtual BOOL OnInitDialog();
	afx_msg void OnGetdispinfolstFiles(NMHDR* pNMHDR, LRESULT* pResult);
	afx_msg void OnColumnclicklstFiles(NMHDR* pNMHDR, LRESULT* pResult);
	virtual void OnOK();
	afx_msg void OnDeltaposspnDigits(NMHDR* pNMHDR, LRESULT* pResult);
	afx_msg void OncmdExecute();
	afx_msg void OnChangetxtBaseTemplate();
	afx_msg void OncmdSaveSettings();
	afx_msg void OnContextMenu(CWnd* pWnd, CPoint point);
	afx_msg void OnGetMinMaxInfo(MINMAXINFO FAR* lpMMI);
	afx_msg void OnSize(UINT nType, int cx, int cy);
	afx_msg void OncmdAbout();
	afx_msg void OnMoveUp();
	afx_msg void OnMoveDown();
	//}}AFX_MSG
	afx_msg LONG OnMyItemMoved(WPARAM, LPARAM);
	afx_msg void OnHelpPopup();
	DECLARE_MESSAGE_MAP()
private:
	HICON m_hIcon;
	HACCEL m_hAccelTable;
	BOOL File_Exists(LPCTSTR pszFileName);
	// Member variables
	int			m_intLenParentFolder;
	int			m_intMinNewNameWidth;
	int			m_intMinExtWidth;
	int			m_intMinNameWidth;
	BOOL		m_bSettingsChanged;
	BOOL		m_bNewNamesValid;
	BOOL		m_bExtAscending;
	BOOL		m_bNameAscending;
	UINT		m_nPopupTopic;
	UINT		m_nWhichColumn;
	UINT		m_nMinDigits;
	CWinApp*	m_pApp;
	char **		m_pNewNames;
	// Member functions.
	BOOL Set_New_Names(void);
	BOOL Rename_File(LPCTSTR pszOldName, LPCTSTR pszNewName);
	BOOL Verify_File(int iIndex);
	UINT Parse_Wildcard(LPCTSTR pszOld, LPCTSTR pszWild, LPCTSTR pszSequence,  char * pszNew);
};

//{{AFX_INSERT_LOCATION}}
// Microsoft Developer Studio will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_RENDLG_H__8DC811D2_971D_11D1_A469_444553540000__INCLUDED_)
